<?php
/**
 * Theme Customizer Options
 *
 * @since 1.0.1
 */

require_once 'customizer_constants.php';
require_once 'customizer_extended.php';

/**
 * Contains options array for theme customizer
 * 
 * @param string $type
 * @return array
 */
function prompt_customizer_options($type){
    
    $options = array();
    $sections = array();
    $panels = array();
    $icons = array( 'glass' => 'glass', 'music' => 'music', 'search' => 'search', 'envelope-o' => 'envelope-o', 'heart' => 'heart', 'star' => 'star', 'star-o' => 'star-o', 'user' => 'user', 'film' => 'film', 'th-large' => 'th-large', 'th' => 'th', 'th-list' => 'th-list', 'check' => 'check', 'times' => 'times', 'search-plus' => 'search-plus', 'search-minus' => 'search-minus', 'power-off' => 'power-off', 'signal' => 'signal', 'gear' => 'gear', 'cog' => 'cog', 'trash-o' => 'trash-o', 'home' => 'home', 'file-o' => 'file-o', 'clock-o' => 'clock-o', 'road' => 'road', 'download' => 'download', 'arrow-circle-o-down' => 'arrow-circle-o-down', 'arrow-circle-o-up' => 'arrow-circle-o-up', 'inbox' => 'inbox', 'play-circle-o' => 'play-circle-o', 'rotate-right' => 'rotate-right', 'repeat' => 'repeat', 'refresh' => 'refresh', 'list-alt' => 'list-alt', 'lock' => 'lock', 'flag' => 'flag', 'headphones' => 'headphones', 'volume-off' => 'volume-off', 'volume-down' => 'volume-down', 'volume-up' => 'volume-up', 'qrcode' => 'qrcode', 'barcode' => 'barcode', 'tag' => 'tag', 'tags' => 'tags', 'book' => 'book', 'bookmark' => 'bookmark', 'print' => 'print', 'camera' => 'camera', 'font' => 'font', 'bold' => 'bold', 'italic' => 'italic', 'text-height' => 'text-height', 'text-width' => 'text-width', 'align-left' => 'align-left', 'align-center' => 'align-center', 'align-right' => 'align-right', 'align-justify' => 'align-justify', 'list' => 'list', 'dedent' => 'dedent', 'outdent' => 'outdent', 'indent' => 'indent', 'video-camera' => 'video-camera', 'photo' => 'photo', 'image' => 'image', 'picture-o' => 'picture-o', 'pencil' => 'pencil', 'map-marker' => 'map-marker', 'adjust' => 'adjust', 'tint' => 'tint', 'edit' => 'edit', 'pencil-square-o' => 'pencil-square-o', 'share-square-o' => 'share-square-o', 'check-square-o' => 'check-square-o', 'arrows' => 'arrows', 'step-backward' => 'step-backward', 'fast-backward' => 'fast-backward', 'backward' => 'backward', 'play' => 'play', 'pause' => 'pause', 'stop' => 'stop', 'forward' => 'forward', 'fast-forward' => 'fast-forward', 'step-forward' => 'step-forward', 'eject' => 'eject', 'chevron-left' => 'chevron-left', 'chevron-right' => 'chevron-right', 'plus-circle' => 'plus-circle', 'minus-circle' => 'minus-circle', 'times-circle' => 'times-circle', 'check-circle' => 'check-circle', 'question-circle' => 'question-circle', 'info-circle' => 'info-circle', 'crosshairs' => 'crosshairs', 'times-circle-o' => 'times-circle-o', 'check-circle-o' => 'check-circle-o', 'ban' => 'ban', 'arrow-left' => 'arrow-left', 'arrow-right' => 'arrow-right', 'arrow-up' => 'arrow-up', 'arrow-down' => 'arrow-down', 'mail-forward' => 'mail-forward', 'share' => 'share', 'expand' => 'expand', 'compress' => 'compress', 'plus' => 'plus', 'minus' => 'minus', 'asterisk' => 'asterisk', 'exclamation-circle' => 'exclamation-circle', 'gift' => 'gift', 'leaf' => 'leaf', 'fire' => 'fire', 'eye' => 'eye', 'eye-slash' => 'eye-slash', 'warning' => 'warning', 'exclamation-triangle' => 'exclamation-triangle', 'plane' => 'plane', 'calendar' => 'calendar', 'random' => 'random', 'comment' => 'comment', 'magnet' => 'magnet', 'chevron-up' => 'chevron-up', 'chevron-down' => 'chevron-down', 'retweet' => 'retweet', 'shopping-cart' => 'shopping-cart', 'folder' => 'folder', 'folder-open' => 'folder-open', 'arrows-v' => 'arrows-v', 'arrows-h' => 'arrows-h', 'bar-chart-o' => 'bar-chart-o', 'twitter-square' => 'twitter-square', 'facebook-square' => 'facebook-square', 'camera-retro' => 'camera-retro', 'key' => 'key', 'gears' => 'gears', 'cogs' => 'cogs', 'comments' => 'comments', 'thumbs-o-up' => 'thumbs-o-up', 'thumbs-o-down' => 'thumbs-o-down', 'star-half' => 'star-half', 'heart-o' => 'heart-o', 'sign-out' => 'sign-out', 'linkedin-square' => 'linkedin-square', 'thumb-tack' => 'thumb-tack', 'external-link' => 'external-link', 'sign-in' => 'sign-in', 'trophy' => 'trophy', 'github-square' => 'github-square', 'upload' => 'upload', 'lemon-o' => 'lemon-o', 'phone' => 'phone', 'square-o' => 'square-o', 'bookmark-o' => 'bookmark-o', 'phone-square' => 'phone-square', 'twitter' => 'twitter', 'facebook' => 'facebook', 'github' => 'github', 'unlock' => 'unlock', 'credit-card' => 'credit-card', 'rss' => 'rss', 'hdd-o' => 'hdd-o', 'bullhorn' => 'bullhorn', 'bell' => 'bell', 'certificate' => 'certificate', 'hand-o-right' => 'hand-o-right', 'hand-o-left' => 'hand-o-left', 'hand-o-up' => 'hand-o-up', 'hand-o-down' => 'hand-o-down', 'arrow-circle-left' => 'arrow-circle-left', 'arrow-circle-right' => 'arrow-circle-right', 'arrow-circle-up' => 'arrow-circle-up', 'arrow-circle-down' => 'arrow-circle-down', 'globe' => 'globe', 'wrench' => 'wrench', 'tasks' => 'tasks', 'filter' => 'filter', 'briefcase' => 'briefcase', 'arrows-alt' => 'arrows-alt', 'group' => 'group', 'users' => 'users', 'chain' => 'chain', 'link' => 'link', 'cloud' => 'cloud', 'flask' => 'flask', 'cut' => 'cut', 'scissors' => 'scissors', 'copy' => 'copy', 'files-o' => 'files-o', 'paperclip' => 'paperclip', 'save' => 'save', 'floppy-o' => 'floppy-o', 'square' => 'square', 'navicon' => 'navicon', 'reorder' => 'reorder', 'bars' => 'bars', 'list-ul' => 'list-ul', 'list-ol' => 'list-ol', 'strikethrough' => 'strikethrough', 'underline' => 'underline', 'table' => 'table', 'magic' => 'magic', 'truck' => 'truck', 'pinterest' => 'pinterest', 'pinterest-square' => 'pinterest-square', 'google-plus-square' => 'google-plus-square', 'google-plus' => 'google-plus', 'money' => 'money', 'caret-down' => 'caret-down', 'caret-up' => 'caret-up', 'caret-left' => 'caret-left', 'caret-right' => 'caret-right', 'columns' => 'columns', 'unsorted' => 'unsorted', 'sort' => 'sort', 'sort-down' => 'sort-down', 'sort-desc' => 'sort-desc', 'sort-up' => 'sort-up', 'sort-asc' => 'sort-asc', 'envelope' => 'envelope', 'linkedin' => 'linkedin', 'rotate-left' => 'rotate-left', 'undo' => 'undo', 'legal' => 'legal', 'gavel' => 'gavel', 'dashboard' => 'dashboard', 'tachometer' => 'tachometer', 'comment-o' => 'comment-o', 'comments-o' => 'comments-o', 'flash' => 'flash', 'bolt' => 'bolt', 'sitemap' => 'sitemap', 'umbrella' => 'umbrella', 'paste' => 'paste', 'clipboard' => 'clipboard', 'lightbulb-o' => 'lightbulb-o', 'exchange' => 'exchange', 'cloud-download' => 'cloud-download', 'cloud-upload' => 'cloud-upload', 'user-md' => 'user-md', 'stethoscope' => 'stethoscope', 'suitcase' => 'suitcase', 'bell-o' => 'bell-o', 'coffee' => 'coffee', 'cutlery' => 'cutlery', 'file-text-o' => 'file-text-o', 'building-o' => 'building-o', 'hospital-o' => 'hospital-o', 'ambulance' => 'ambulance', 'medkit' => 'medkit', 'fighter-jet' => 'fighter-jet', 'beer' => 'beer', 'h-square' => 'h-square', 'plus-square' => 'plus-square', 'angle-double-left' => 'angle-double-left', 'angle-double-right' => 'angle-double-right', 'angle-double-up' => 'angle-double-up', 'angle-double-down' => 'angle-double-down', 'angle-left' => 'angle-left', 'angle-right' => 'angle-right', 'angle-up' => 'angle-up', 'angle-down' => 'angle-down', 'desktop' => 'desktop', 'laptop' => 'laptop', 'tablet' => 'tablet', 'mobile-phone' => 'mobile-phone', 'mobile' => 'mobile', 'circle-o' => 'circle-o', 'quote-left' => 'quote-left', 'quote-right' => 'quote-right', 'spinner' => 'spinner', 'circle' => 'circle', 'mail-reply' => 'mail-reply', 'reply' => 'reply', 'github-alt' => 'github-alt', 'folder-o' => 'folder-o', 'folder-open-o' => 'folder-open-o', 'smile-o' => 'smile-o', 'frown-o' => 'frown-o', 'meh-o' => 'meh-o', 'gamepad' => 'gamepad', 'keyboard-o' => 'keyboard-o', 'flag-o' => 'flag-o', 'flag-checkered' => 'flag-checkered', 'terminal' => 'terminal', 'code' => 'code', 'mail-reply-all' => 'mail-reply-all', 'reply-all' => 'reply-all', 'star-half-empty' => 'star-half-empty', 'star-half-full' => 'star-half-full', 'star-half-o' => 'star-half-o', 'location-arrow' => 'location-arrow', 'crop' => 'crop', 'code-fork' => 'code-fork', 'unlink' => 'unlink', 'chain-broken' => 'chain-broken', 'question' => 'question', 'info' => 'info', 'exclamation' => 'exclamation', 'superscript' => 'superscript', 'subscript' => 'subscript', 'eraser' => 'eraser', 'puzzle-piece' => 'puzzle-piece', 'microphone' => 'microphone', 'microphone-slash' => 'microphone-slash', 'shield' => 'shield', 'calendar-o' => 'calendar-o', 'fire-extinguisher' => 'fire-extinguisher', 'rocket' => 'rocket', 'maxcdn' => 'maxcdn', 'chevron-circle-left' => 'chevron-circle-left', 'chevron-circle-right' => 'chevron-circle-right', 'chevron-circle-up' => 'chevron-circle-up', 'chevron-circle-down' => 'chevron-circle-down', 'html5' => 'html5', 'css3' => 'css3', 'anchor' => 'anchor', 'unlock-alt' => 'unlock-alt', 'bullseye' => 'bullseye', 'ellipsis-h' => 'ellipsis-h', 'ellipsis-v' => 'ellipsis-v', 'rss-square' => 'rss-square', 'play-circle' => 'play-circle', 'ticket' => 'ticket', 'minus-square' => 'minus-square', 'minus-square-o' => 'minus-square-o', 'level-up' => 'level-up', 'level-down' => 'level-down', 'check-square' => 'check-square', 'pencil-square' => 'pencil-square', 'external-link-square' => 'external-link-square', 'share-square' => 'share-square', 'compass' => 'compass', 'toggle-down' => 'toggle-down', 'caret-square-o-down' => 'caret-square-o-down', 'toggle-up' => 'toggle-up', 'caret-square-o-up' => 'caret-square-o-up', 'toggle-right' => 'toggle-right', 'caret-square-o-right' => 'caret-square-o-right', 'euro' => 'euro', 'eur' => 'eur', 'gbp' => 'gbp', 'dollar' => 'dollar', 'usd' => 'usd', 'rupee' => 'rupee', 'inr' => 'inr', 'cny' => 'cny', 'rmb' => 'rmb', 'yen' => 'yen', 'jpy' => 'jpy', 'ruble' => 'ruble', 'rouble' => 'rouble', 'rub' => 'rub', 'won' => 'won', 'krw' => 'krw', 'bitcoin' => 'bitcoin', 'btc' => 'btc', 'file' => 'file', 'file-text' => 'file-text', 'sort-alpha-asc' => 'sort-alpha-asc', 'sort-alpha-desc' => 'sort-alpha-desc', 'sort-amount-asc' => 'sort-amount-asc', 'sort-amount-desc' => 'sort-amount-desc', 'sort-numeric-asc' => 'sort-numeric-asc', 'sort-numeric-desc' => 'sort-numeric-desc', 'thumbs-up' => 'thumbs-up', 'thumbs-down' => 'thumbs-down', 'youtube-square' => 'youtube-square', 'youtube' => 'youtube', 'xing' => 'xing', 'xing-square' => 'xing-square', 'youtube-play' => 'youtube-play', 'dropbox' => 'dropbox', 'stack-overflow' => 'stack-overflow', 'instagram' => 'instagram', 'flickr' => 'flickr', 'adn' => 'adn', 'bitbucket' => 'bitbucket', 'bitbucket-square' => 'bitbucket-square', 'tumblr' => 'tumblr', 'tumblr-square' => 'tumblr-square', 'long-arrow-down' => 'long-arrow-down', 'long-arrow-up' => 'long-arrow-up', 'long-arrow-left' => 'long-arrow-left', 'long-arrow-right' => 'long-arrow-right', 'apple' => 'apple', 'windows' => 'windows', 'android' => 'android', 'linux' => 'linux', 'dribbble' => 'dribbble', 'skype' => 'skype', 'foursquare' => 'foursquare', 'trello' => 'trello', 'female' => 'female', 'male' => 'male', 'gittip' => 'gittip', 'sun-o' => 'sun-o', 'moon-o' => 'moon-o', 'archive' => 'archive', 'bug' => 'bug', 'vk' => 'vk', 'weibo' => 'weibo', 'renren' => 'renren', 'pagelines' => 'pagelines', 'stack-exchange' => 'stack-exchange', 'arrow-circle-o-right' => 'arrow-circle-o-right', 'arrow-circle-o-left' => 'arrow-circle-o-left', 'toggle-left' => 'toggle-left', 'caret-square-o-left' => 'caret-square-o-left', 'dot-circle-o' => 'dot-circle-o', 'wheelchair' => 'wheelchair', 'vimeo-square' => 'vimeo-square', 'turkish-lira' => 'turkish-lira', 'try' => 'try', 'plus-square-o' => 'plus-square-o', 'space-shuttle' => 'space-shuttle', 'slack' => 'slack', 'envelope-square' => 'envelope-square', 'wordpress' => 'wordpress', 'openid' => 'openid', 'institution' => 'institution', 'bank' => 'bank', 'university' => 'university', 'mortar-board' => 'mortar-board', 'graduation-cap' => 'graduation-cap', 'yahoo' => 'yahoo', 'google' => 'google', 'reddit' => 'reddit', 'reddit-square' => 'reddit-square', 'stumbleupon-circle' => 'stumbleupon-circle', 'stumbleupon' => 'stumbleupon', 'delicious' => 'delicious', 'digg' => 'digg', 'pied-piper-square' => 'pied-piper-square', 'pied-piper' => 'pied-piper', 'pied-piper-alt' => 'pied-piper-alt', 'drupal' => 'drupal', 'joomla' => 'joomla', 'language' => 'language', 'fax' => 'fax', 'building' => 'building', 'child' => 'child', 'paw' => 'paw', 'spoon' => 'spoon', 'cube' => 'cube', 'cubes' => 'cubes', 'behance' => 'behance', 'behance-square' => 'behance-square', 'steam' => 'steam', 'steam-square' => 'steam-square', 'recycle' => 'recycle', 'automobile' => 'automobile', 'car' => 'car', 'cab' => 'cab', 'taxi' => 'taxi', 'tree' => 'tree', 'spotify' => 'spotify', 'deviantart' => 'deviantart', 'soundcloud' => 'soundcloud', 'database' => 'database', 'file-pdf-o' => 'file-pdf-o', 'file-word-o' => 'file-word-o', 'file-excel-o' => 'file-excel-o', 'file-powerpoint-o' => 'file-powerpoint-o', 'file-photo-o' => 'file-photo-o', 'file-picture-o' => 'file-picture-o', 'file-image-o' => 'file-image-o', 'file-zip-o' => 'file-zip-o', 'file-archive-o' => 'file-archive-o', 'file-sound-o' => 'file-sound-o', 'file-audio-o' => 'file-audio-o', 'file-movie-o' => 'file-movie-o', 'file-video-o' => 'file-video-o', 'file-code-o' => 'file-code-o', 'vine' => 'vine', 'codepen' => 'codepen', 'jsfiddle' => 'jsfiddle', 'life-bouy' => 'life-bouy', 'life-saver' => 'life-saver', 'support' => 'support', 'life-ring' => 'life-ring', 'circle-o-notch' => 'circle-o-notch', 'ra' => 'ra', 'rebel' => 'rebel', 'ge' => 'ge', 'empire' => 'empire', 'git-square' => 'git-square', 'git' => 'git', 'hacker-news' => 'hacker-news', 'tencent-weibo' => 'tencent-weibo', 'qq' => 'qq', 'wechat' => 'wechat', 'weixin' => 'weixin', 'send' => 'send', 'paper-plane' => 'paper-plane', 'send-o' => 'send-o', 'paper-plane-o' => 'paper-plane-o', 'history' => 'history', 'circle-thin' => 'circle-thin', 'header' => 'header', 'paragraph' => 'paragraph', 'sliders' => 'sliders', 'share-alt' => 'share-alt', 'share-alt-square' => 'share-alt-square', 'bomb' => 'bomb');
    $num_by_hundred = array('100'=>'100', '200'=>'200', '300'=>'300', '400'=>'400', '500'=>'500', '600'=>'600', '700'=>'700', '800'=>'800', '900'=>'900', '1000'=>'1000', '1100'=>'1100', '1200'=>'1200', '1300'=>'1300', '1400'=>'1400', '1500'=>'1500', '1600'=>'1600', '1700'=>'1700', '1800'=>'1800', '1900'=>'1900', '2000'=>'2000', '2100'=>'2100', '2200'=>'2200', '2300'=>'2300', '2400'=>'2400', '2500'=>'2500', '2600'=>'2600', '2700'=>'2700', '2800'=>'2800', '2900'=>'2900', '3000'=>'3000', '3100'=>'3100', '3200'=>'3200', '3300'=>'3300', '3400'=>'3400', '3500'=>'3500', '3600'=>'3600', '3700'=>'3700', '3800'=>'3800', '3900'=>'3900', '4000'=>'4000', '4100'=>'4100', '4200'=>'4200', '4300'=>'4300', '4400'=>'4400', '4500'=>'4500', '4600'=>'4600', '4700'=>'4700', '4800'=>'4800', '4900'=>'4900', '5000'=>'5000', '5100'=>'5100', '5200'=>'5200', '5300'=>'5300', '5400'=>'5400', '5500'=>'5500', '5600'=>'5600', '5700'=>'5700', '5800'=>'5800', '5900'=>'5900', '6000'=>'6000', '6100'=>'6100', '6200'=>'6200', '6300'=>'6300', '6400'=>'6400', '6500'=>'6500', '6600'=>'6600', '6700'=>'6700', '6800'=>'6800', '6900'=>'6900', '7000'=>'7000', '7100'=>'7100', '7200'=>'7200', '7300'=>'7300', '7400'=>'7400', '7500'=>'7500', '7600'=>'7600', '7700'=>'7700', '7800'=>'7800', '7900'=>'7900', '8000'=>'8000', '8100'=>'8100', '8200'=>'8200', '8300'=>'8300', '8400'=>'8400', '8500'=>'8500', '8600'=>'8600', '8700'=>'8700', '8800'=>'8800', '8900'=>'8900', '9000'=>'9000', '9100'=>'9100', '9200'=>'9200', '9300'=>'9300', '9400'=>'9400', '9500'=>'9500', '9600'=>'9600', '9700'=>'9700', '9800'=>'9800', '9900'=>'9900', '10000'=>'10000');
    
    $panels[] = array(
        'id' => 'prompt_panel_general',
        'title' => __('General','prompt'),
        'description' => '',
        'priority' => 20,
    );

    $sections[] = array(
        'id' => 'prompt_section_basic_settings',
        'title' => __('Basic Settings','prompt'),
        'description' => '',
        'panel' => '',
        'priority' => 21,
        'shortname' => 'section_basic_settings',
    );

    $options[] = array(
        'id' => 'logo_img',
        'default' => '',
        'label' => __('Site Logo','prompt'),
        'description' => '',
        'type' => 'media_upload',
        'sanitize_type' => 'media_upload',
        'section' => 'section_basic_settings',
        'extended_class' => 'WP_Customize_Image_Control',
        'transport' => 'refresh'
    );
    
    $options[] = array(
        'id' => 'footer_name',
        'default' => '',
        'label' => __('Company Name', 'prompt'),
        'description' => '',
        'type' => 'text',
        'sanitize_type' => 'nohtml',
        'section' => 'section_basic_settings',
        'extended_class' => false,
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'disable_header',
        'default' => false,
        'label' => __('Hide Header','prompt'),
        'description' => '',
        'type' => 'checkbox',
        'sanitize_type' => 'checkbox',
        'section' => 'section_basic_settings',
        'extended_class' => false,
        'transport' => 'refresh'
    );
    
    $options[] = array(
        'id' => 'disable_footer',
        'default' => false,
        'label' => __('Hide Footer','prompt'),
        'description' => '',
        'type' => 'checkbox',
        'sanitize_type' => 'checkbox',
        'section' => 'section_basic_settings',
        'extended_class' => false,
        'transport' => 'refresh'
    );
    
    $options[] = array(
        'id' => 'disable_site_desc',
        'default' => true,
        'label' => __('Hide Site Description','prompt'),
        'description' => '',
        'type' => 'checkbox',
        'sanitize_type' => 'checkbox',
        'section' => 'section_basic_settings',
        'extended_class' => false,
        'transport' => 'refresh'
    );
    
    $options[] = array(
        'id' => 'disable_menu',
        'default' => false,
        'label' => __('Hide Menu','prompt'),
        'description' => '',
        'type' => 'checkbox',
        'sanitize_type' => 'checkbox',
        'section' => 'section_basic_settings',
        'extended_class' => false,
        'transport' => 'refresh'
    );
    
    $options[] = array(
        'id' => 'show_copyright',
        'default' => true,
        'label' => __('Show Copyright','prompt'),
        'description' => '',
        'type' => 'checkbox',
        'sanitize_type' => 'checkbox',
        'section' => 'section_basic_settings',
        'extended_class' => false,
        'transport' => 'refresh'
    );
    
    $sections[] = array(
        'id' => 'prompt_section_featured_section',
        'title' => __('Featured Section','prompt'),
        'description' => '',
        'panel' => '',
        'priority' => 22,
        'shortname' => 'section_featured_section',
    );

    $options[] = array(
        'id' => 'disable_cta_section',
        'default' => false,
        'label' => __('Hide Featured Section','prompt'),
        'description' => '',
        'type' => 'checkbox',
        'sanitize_type' => 'checkbox',
        'section' => 'section_featured_section',
        'extended_class' => false,
        'transport' => 'refresh'
    );
    
    $options[] = array(
        'id' => 'disable_cta_buttons',
        'default' => false,
        'label' => __('Hide Buttons','prompt'),
        'description' => '',
        'type' => 'checkbox',
        'sanitize_type' => 'checkbox',
        'section' => 'section_featured_section',
        'extended_class' => false,
        'transport' => 'refresh'
    );
    
    $options[] = array(
        'id' => 'disable_cta_icons',
        'default' => false,
        'label' => __('Hide Icons','prompt'),
        'description' => '',
        'type' => 'checkbox',
        'sanitize_type' => 'checkbox',
        'section' => 'section_featured_section',
        'extended_class' => false,
        'transport' => 'refresh'
    );
    
    $options[] = array(
        'id' => 'featured_heading',
        'default' => __('Headlines Text !','prompt'),
        'label' => __('Featured Heading', 'prompt'),
        'description' => '',
        'type' => 'text',
        'sanitize_type' => 'nohtml',
        'section' => 'section_featured_section',
        'extended_class' => false,
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'featured_content',
        'default' => __('This is the featured section of Prompt Theme. In order to change this text. Go to Customize (Featured Section). If you are unable to do so then please see the theme documentation or contact support.','prompt'),
        'label' => __('Featured Content', 'prompt'),
        'description' => '',
        'type' => 'text',
        'sanitize_type' => 'nohtml',
        'section' => 'section_featured_section',
        'extended_class' => false,
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'featured_content_bottom',
        'default' => __('This is the featured section of Prompt Theme. In order to change this text. Go to Customize (Featured Section). If you are unable to do so then please see the theme documentation or contact support.','prompt'),
        'label' => __('Featured Content Bottom', 'prompt'),
        'description' => '',
        'type' => 'text',
        'sanitize_type' => 'nohtml',
        'section' => 'section_featured_section',
        'extended_class' => false,
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'cta_button_1',
        'default' => __('Button #1','prompt'),
        'label' => __('CTA Button #1', 'prompt'),
        'description' => '',
        'type' => 'text',
        'sanitize_type' => 'nohtml',
        'section' => 'section_featured_section',
        'extended_class' => false,
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'cta_button_url_1',
        'default' => 'http://www.mudthemes.com',
        'label' => __('CTA Button #1 (URL)', 'prompt'),
        'description' => '',
        'type' => 'text',
        'sanitize_type' => 'url',
        'section' => 'section_featured_section',
        'extended_class' => false,
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'cta_button_icon_1',
        'default' => 'check',
        'label' => __('CTA Button #1 Icon', 'prompt'),
        'description' => '',
        'type' => 'select',
        'sanitize_type' => 'select',
        'section' => 'section_featured_section',
        'extended_class' => false,
        'choices' => $icons,
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'cta_button_2',
        'default' => __('Button #2','prompt'),
        'label' => __('CTA Button #2', 'prompt'),
        'description' => '',
        'type' => 'text',
        'sanitize_type' => 'nohtml',
        'section' => 'section_featured_section',
        'extended_class' => false,
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'cta_button_url_2',
        'default' => 'http://www.mudthemes.com',
        'label' => __('CTA Button #2 (URL)', 'prompt'),
        'description' => '',
        'type' => 'text',
        'sanitize_type' => 'url',
        'section' => 'section_featured_section',
        'extended_class' => false,
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'cta_button_icon_2',
        'default' => 'download',
        'label' => __('CTA Button #2 Icon', 'prompt'),
        'description' => '',
        'type' => 'select',
        'sanitize_type' => 'select',
        'section' => 'section_featured_section',
        'extended_class' => false,
        'choices' => $icons,
        'transport' => 'refresh'
    );

    $sections[] = array(
        'id' => 'prompt_section_slideshow',
        'title' => __('Slideshow','prompt'),
        'description' => '',
        'panel' => '',
        'priority' => 23,
        'shortname' => 'section_slideshow',
    );

    $options[] = array(
        'id' => 'carousel',
        'default' => 'featured',
        'label' => __('Carousel Type', 'prompt'),
        'description' => '',
        'type' => 'select',
        'sanitize_type' => 'select',
        'section' => 'section_slideshow',
        'extended_class' => false,
        'choices' => array('slideshow' => 'Slideshow', 'featured' => 'Featured Image'),
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'slide_speed',
        'default' => '5000',
        'label' => __('Slideshow Speed', 'prompt'),
        'description' => '',
        'type' => 'select',
        'sanitize_type' => 'select',
        'section' => 'section_slideshow',
        'extended_class' => false,
        'choices' => $num_by_hundred,
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'slide_ani_speed',
        'default' => '700',
        'label' => __('Slideshow Animation Speed', 'prompt'),
        'description' => '',
        'type' => 'select',
        'sanitize_type' => 'select',
        'section' => 'section_slideshow',
        'extended_class' => false,
        'choices' => $num_by_hundred,
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'disable_slide_nav',
        'default' => false,
        'label' => __('Hide Navigation','prompt'),
        'description' => '',
        'type' => 'checkbox',
        'sanitize_type' => 'checkbox',
        'section' => 'section_slideshow',
        'extended_class' => false,
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'disable_smooth_height',
        'default' => true,
        'label' => __('Smooth Height','prompt'),
        'description' => '',
        'type' => 'checkbox',
        'sanitize_type' => 'checkbox',
        'section' => 'section_slideshow',
        'extended_class' => false,
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'slide_animation_type',
        'default' => 'fade',
        'label' => __('Animation Type', 'prompt'),
        'description' => '',
        'type' => 'select',
        'sanitize_type' => 'select',
        'section' => 'section_slideshow',
        'extended_class' => false,
        'choices' => array('fade' => 'fade', 'slide' => 'slide'),
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'slide_dir',
        'default' => 'horizontal',
        'label' => __('Slideshow Direction', 'prompt'),
        'description' => '',
        'type' => 'select',
        'sanitize_type' => 'select',
        'section' => 'section_slideshow',
        'extended_class' => false,
        'choices' => array('horizontal' => 'horizontal', 'vertical' => 'vertical'),
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'slide_img_1',
        'default' => '',
        'label' => __('Slideshow Image #1','prompt'),
        'description' => '',
        'type' => 'media_upload',
        'sanitize_type' => 'media_upload',
        'section' => 'section_slideshow',
        'extended_class' => 'WP_Customize_Image_Control',
        'transport' => 'refresh'
    );
    
    $options[] = array(
        'id' => 'slide_img_2',
        'default' => '',
        'label' => __('Slideshow Image #2','prompt'),
        'description' => '',
        'type' => 'media_upload',
        'sanitize_type' => 'media_upload',
        'section' => 'section_slideshow',
        'extended_class' => 'WP_Customize_Image_Control',
        'transport' => 'refresh'
    );
    
    $sections[] = array(
        'id' => 'prompt_section_social_profiles',
        'title' => __('Social Profiles','prompt'),
        'description' => '',
        'panel' => '',
        'priority' => 24,
        'shortname' => 'section_social_profiles',
    );

    $options[] = array(
        'id' => 'disable_social_section',
        'default' => false,
        'label' => __('Hide Social Section','prompt'),
        'description' => '',
        'type' => 'checkbox',
        'sanitize_type' => 'checkbox',
        'section' => 'section_social_profiles',
        'extended_class' => false,
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'facebook',
        'default' => '',
        'label' => __('Facebook', 'prompt'),
        'description' => '',
        'type' => 'text',
        'sanitize_type' => 'url',
        'section' => 'section_social_profiles',
        'extended_class' => false,
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'twitter',
        'default' => '',
        'label' => __('Twitter', 'prompt'),
        'description' => '',
        'type' => 'text',
        'sanitize_type' => 'url',
        'section' => 'section_social_profiles',
        'extended_class' => false,
        'transport' => 'refresh'
    );

    $options[] = array(
        'id' => 'rss',
        'default' => '',
        'label' => __('RSS', 'prompt'),
        'description' => '',
        'type' => 'text',
        'sanitize_type' => 'url',
        'section' => 'section_social_profiles',
        'extended_class' => false,
        'transport' => 'refresh'
    );

    $sections[] = array(
        'id' => 'prompt_section_about',
        'title' => __('About Prompt Theme','prompt'),
        'description' => '',
        'panel' => '',
        'priority' => 120,
        'shortname' => 'section_about',
    );

    $options[] = array(
        'id' => 'important_links',
        'default' => '',
        'label' => __('','prompt'),
        'description' => '',
        'type' => 'important_links',
        'sanitize_type' => 'none',
        'section' => 'section_about',
        'extended_class' => 'Prompt_Customize_Important_Links_Control',
        'transport' => 'refresh'
    );


    switch($type):
        case 'panels':
            return $panels;
        case 'sections':
            return $sections;
        case 'options':
            return $options;
        default:
            return;
    endswitch;
}

/**
 * Build Theme Customizer Options
 * 
 * @param type $wp_customize
 */
function prompt_customizer_setup($wp_customize) {
    
    /**
     * Exit if $wp_customize does not exist.
     */
    if( !isset($wp_customize)) {
        return;
    }
    
    $panels = prompt_customizer_options('panels');
    $sections = prompt_customizer_options('sections');
    $options = prompt_customizer_options('options');
    
    foreach($panels as $panel) {
        $wp_customize->add_panel($panel['id'], array(
            'title' => $panel['title'],
            'description' => $panel['description'],
            'theme_supports' => '',
            'capability' => 'edit_theme_options',
            'priority' => $panel['priority'],
        ));
    }
    
    foreach($sections as $section) {
        $wp_customize->add_section($section['id'], array(
            'title' => $section['title'],
            'description' => $section['description'],
            'panel' => $section['panel'],
            'priority' => $section['priority'],
        ));
    }
    
    foreach($options as $option) {
        $wp_customize->add_setting('prompt['.$option['id'].']', array(
            'type' => 'option',
            'default' => $option['default'],
            'capability' => 'edit_theme_options',
            'sanitize_callback' => prompt_get_sanitize_filter($option['sanitize_type']),
            'transport' => $option['transport'],
        ));
        
        if (!$option['extended_class']) {
            $wp_customize->add_control('prompt[' . $option['id'] . ']', array(
                'label' => $option['label'],
                'description' => $option['description'],
                'type' => $option['type'],
                'section' => prompt_get_sections($option['section']),
                'setting' => $option['id'],
                'choices' => array_key_exists('choices', $option) ? $option['choices'] : false,
            ));
        } else {
            $wp_customize->add_control(new $option['extended_class'](
                $wp_customize, 'prompt[' . $option['id'] . ']', array(
                'label' => $option['label'],
                'description' => $option['description'],
                'section' => prompt_get_sections($option['section']),
                'setting' => $option['id'],
                'choices' => array_key_exists('choices', $option) ? $option['choices'] : false,
                )
            ));
        }
}
	
	// WP Defaults
	$wp_customize->get_section('title_tagline')->panel = 'prompt_panel_general';
	$wp_customize->get_section('static_front_page')->panel = 'prompt_panel_general';
	$wp_customize->get_control('background_color')->section = 'prompt_section_colors_global';
	$wp_customize->get_control('background_image')->section = 'prompt_section_colors_global';
	$wp_customize->remove_section('background_image');
	
}
add_action( 'customize_register', 'prompt_customizer_setup' );



/**
 * Enqueue Customizer Live Preview Scripts
 * 
 * @todo complete this
 */
function prompt_live_preview_scripts(){
    wp_enqueue_script('prompt-themecustomizer-live-preview', PROMPT_ADMIN_JS_URL . 'customizer.js', array('jquery', 'customize-preview'),'', true);
}
add_action('customize_preview_init','prompt_live_preview_scripts');



/**
 * Enqueue admin panel CSS - (Primarily for customizer)
 *
 * @since 1.0
 */
function prompt_admin_panel_style($hook) {
    
    if($hook == 'widgets.php'){
	wp_enqueue_style( 'prompt-admin-panel-css', PROMPT_ADMIN_CSS_URL . 'admin.css' );
	wp_enqueue_script( 'prompt-admin-panel-js', PROMPT_ADMIN_JS_URL . 'admin.js', array('jquery'), '1.0.0', TRUE );
        wp_localize_script('prompt-admin-panel-js', 'promptCustomizerUpgradeVars', array('upgrade_text' => __('Upgrade to Premium', 'prompt')));
    }
}
add_action( 'admin_enqueue_scripts', 'prompt_admin_panel_style' );



/**
 * Gets the value of an option.
 * Also sets caching for default options.
 * 
 * @global array $prompt_options Options cache.
 * @param string $id Option ID
 * @return string Option Value
 */
function prompt_get_option($id = NULL) {
    global $prompt_options;
    
    // Global array exists. Get value from memory
    if($prompt_options && array_key_exists($id, $prompt_options)) {
        return $prompt_options[$id];
    } else {
        
        // No value in Memory. Try fetching from DB
        $saved_options = get_option('prompt');
        
        if($saved_options && array_key_exists($id, $saved_options)){
            
            $prompt_options = $saved_options;
            return $prompt_options[$id];
            
        } else {
            
            // No value in Memory or DB. Get it from default options.
            $sane_options = prompt_customizer_options('options');
            $prompt_options = array();
            
            foreach($sane_options as $options) {
                if($id == $options['id'] ){
                    $prompt_options[$options['id']] = $options['default'];
                    break;
                }                
            }

            return $prompt_options[$id];

        }
    }
}


/**
 * Returns sanitization filter functions
 * 
 * @param string $type The type of input to be sanitized
 * @return string Sanitization function name
 */
function prompt_get_sanitize_filter($type){
    $filters = array(
        'html' => 'prompt_sanitize_html',
        'nohtml' => 'prompt_sanitize_nohtml', // Only Text
        'url' => 'prompt_sanitize_url',
        'checkbox' => 'prompt_sanitize_checkbox',
        'select' => 'prompt_sanitize_select',
        'color' => 'prompt_sanitize_hex_color',
        'media_upload' => 'prompt_sanitize_media_upload',
        'none' => 'prompt_sanitize_none'
    );
    
    return $filters[$type];
}


/**
 * Returns the section based on shortname
 * 
 * @param string $shortname
 * @return string
 */
function prompt_get_sections($shortname) {
    $sections = prompt_customizer_options('sections');
    foreach ($sections as $section) {
        if($section['shortname'] == $shortname){
            return $section['id'];
        }
    }
}


/**
 * Sanitization Function for No HTML content (only text)
 *
 * @param string $nohtml
 * @return string
 */
function prompt_sanitize_nohtml($nohtml) {
	return wp_filter_nohtml_kses( $nohtml );
}


/**
 * Sanitization Function for only HTML content
 *
 * @param string $html
 * @return string
 */
function prompt_sanitize_html($html) {
	return wp_filter_post_kses( $html );
}


/**
 * Sanitization Function for URL
 * 
 * @param string $url
 * @return string
 */
function prompt_sanitize_url($url){
    return esc_url_raw($url);
}


/**
 * Sanitization Function for Checkbox
 * 
 * @param boolean $checked
 * @return boolean
 */
function prompt_sanitize_checkbox($checked){
    return ( ( isset( $checked ) && true == $checked ) ? true : false );
}


/**
 * Sanitization Function for Select/Radio
 * 
 * @param String $input Slug to sanitize
 * @param WP_Customize_Setting $setting Setting instance
 * @return String Sanitized slug if it is a valid choice; otherwise, the setting default
 */
function prompt_sanitize_select($input, $setting) {
    // Ensure input is a slug.
    $input = sanitize_key($input);

    // Get list of choices from the control associated with the setting.
    $choices = $setting->manager->get_control($setting->id)->choices;

    // If the input is a valid key, return it; otherwise, return the default.
    return ( array_key_exists($input, $choices) ? $input : $setting->default );
}


/**
 * Sanitization Function for Hex Colors
 * 
 * @param string HEX color to sanitize
 * @param WP_Customize_Setting Setting instance
 */
function prompt_sanitize_hex_color($hex_color, $setting){
	// Sanitize $input as a hex value without the hash prefix.
	$hex_color = sanitize_hex_color( $hex_color );
	
	// If $input is a valid hex value, return it; otherwise, return the default.
	return ( ( $hex_color ) ? $hex_color : $setting->default );
}


/**
 * Sanitization Function for Image Upload via Media Manager
 * 
 * @param string Image filename
 * @param WP_Customize_Setting Setting instance
 * @return string The image filename if the extension is allowed; otherwise, the setting default.
 */
function prompt_sanitize_media_upload( $image, $setting ) {

	/*
	 * Array of valid image file types.
	 *
	 * The array includes image mime types that are included in wp_get_mime_types()
	 */
    $mimes = array(
        'jpg|jpeg|jpe' => 'image/jpeg',
        'gif'          => 'image/gif',
        'png'          => 'image/png',
        'bmp'          => 'image/bmp',
        'tif|tiff'     => 'image/tiff',
        'ico'          => 'image/x-icon'
    );

	// Return an array with file extension and mime_type.
    $file = wp_check_filetype( $image, $mimes );

	// If $image has a valid mime_type, return it; otherwise, return the default.
    return ( $file['ext'] ? $image : $setting->default );
}


/**
 * Sanitizes nothing (Used for Theme Upgrade Text)
 */
function prompt_sanitize_none(){
	return;
}